/*
    DEMO:     bitova scitacka
    VARIANTA: bez preruseni
    25.10.2007

    ing.Rudolf Schonecker & ing.Zbynek Krivka
    schonec@fit.vutbr.cz, krivka@fit.vutbr.cz

    OVLADANI:
      1) zadani cisla A (lze pouzit pouze znaky '0' nebo '1')
      2) stisknuti klavesy '#' => +
      3) zadani cisla B (lze pouzit pouze znaky '0' nebo '1')
      4) stisknuti klavesy 'D' => =
      5) vypise vysledek
      6) lze pokracovat ad 1)

    - u vstupu ani pri vypoctu se nekontroluje preteceni !!!
*/

#define byte unsigned char
#define bool unsigned char



void keybrd0_Enable(void);
void keybrd0_Enable(void)
{
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    OR      s1, 02               ; nastavi hodnotu enabled do 1
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm
}

void keybrd0_Disable(void);
void keybrd0_Disable(void)
{
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    AND     s1, FD
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm
}

// Funkce keybrd0_EnableEvent a DisableEvent mn generovan HW a podle nich se pak mus do vslednho C kdu vloit
// pslun varianty funkc keybrd0_KbHit a keybrd0_GetKeyCode pro ovldn takovchto bean a mus tomu tak odpovdat
// tvar hlavnho programu!!!
void keybrd0_EnableEvent(void);
void keybrd0_EnableEvent(void)
{
 /*
   Tato funkce povoluje preruseni v samotnem kodu a mela by nastavovat genericky parametr KEYBOARD_USES_INTERRUPT := '1';
   popisu designu v design.xml
 */ 
 
 // povolovani preruseni klavesnice za behu programu (nelze reagovat zmenou funkci beanu, ktere by to meli reflektovat)
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    OR      s1, 01               ; nastavi hodnotu enabled do 1
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm 
}

void keybrd0_DisableEvent(void);
void keybrd0_DisableEvent(void)
{
 /*
   Tato funkce zakazuje preruseni v samotnem kodu a mela by nastavovat genericky parametr KEYBOARD_USES_INTERRUPT := '0';
   popisu designu v design.xml
 */ 
 
 // zakazani preruseni klavesnice za behu programu (nelze reagovat zmenou funkci beanu, ktere by to meli reflektovat)
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    AND     s1, FE
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm 
}

bool keybrd0_KbHit(void);
bool keybrd0_KbHit(void)
{
  #asm
			FETCH			s0, _keybrd0_port
			INPUT     s1, (s0)
			AND       s1, 04
			SR0       s1
			SR0       s1
			LOAD      ZL,s1
  #endasm
}

int keybrd0_GetKeyCode();
int keybrd0_GetKeyCode()
{
  #asm
  		FETCH			s0, _keybrd0_port
      ADD       s0, 01             ; dalsi adresa
      INPUT     s1, (s0)
      LOAD      ZL,s1
      ADD       s0, 01             ; dalsi adresa
      INPUT     s2, (s0)
      LOAD      ZH,s2
  #endasm
}

void keybrd0_SetEdge(byte edge);
void keybrd0_SetEdge(byte edge)
{
  #asm
    FETCH     TMP, (YL)
    FETCH     s3, _keybrd0_port
    INPUT     s4, (s3)
    LOAD      s3, TMP
    SL0       s3
    SL0       s3
    SL0       s3
    OR        s4, s3
    OR        s3, 07
    AND       s4, s3
    FETCH     s3, _keybrd0_port
    OUTPUT    s4, (s3)
  #endasm
}

void lcd0_clr();
void lcd0_clr()
{
  #asm
    FETCH     s3, _lcd0_port
    LOAD      s4, 01
    OUTPUT    s4, (s3)
  #endasm
}

void lcd0_type(byte keycode);
void lcd0_type(byte keycode)
{
  #asm
    FETCH     s3, _lcd0_port
    ADD       s3, 01
    FETCH     TMP, (YL)
    LOAD      s4, TMP
    OUTPUT    s4, (s3)
  #endasm
}



byte bitio0_port;
byte bitio1_port;
byte keybrd0_port;
byte lcd0_port;

void PE_low_level_init();
void PE_low_level_init()
{
  // inicializovat hodnoty portu = konstanty
	bitio0_port		 = 00;     // 00
	bitio1_port	 	 = 05;     // 05
	keybrd0_port	 = 10;     // 0A
	lcd0_port      = 16;     // 10

	lcd0_clr();
	
	keybrd0_DisableEvent();	

	#asm   // nyni lze povolit preruseni..
			DISABLE INTERRUPT
	#endasm
}


byte keystatus2char(int keycode);
byte keystatus2char(int keycode)
{
  byte retval,b1,b2;
  retval = 0;
  b1 = (byte)(keycode>>0); // kod b1 = (byte)(keycode); NEFUNGUJE !!!!!!!!
  b2 = (byte)(keycode>>8);
  if(	  b2>>7 & 1   )    retval = '#';
  if(	  b2>>6 & 1   )    retval = '*';
  if(	  b2>>5 & 1   )    retval = 'D';
  if(	  b2>>4 & 1   )    retval = 'C';
  if(	  b2>>3 & 1   )    retval = 'B';
  if(	  b2>>2 & 1   )    retval = 'A';
  if(	  b2>>1 & 1   )    retval = '9';
  if(	  b2 & 1   )       retval = '8';
  if(	  b1>>7 & 1   )    retval = '7';
  if(	  b1>>6 & 1   )    retval = '6';
  if(	  b1>>5 & 1   )    retval = '5';
  if(	  b1>>4 & 1   )    retval = '4';
  if(	  b1>>3 & 1   )    retval = '3';
  if(	  b1>>2 & 1   )    retval = '2';
  if(	  b1>>1 & 1   )    retval = '1';
  if(	  b1 & 1   )       retval = '0';
  return retval;
}


void print(byte num);
void print(byte num)
{
   byte i;
   i = 8;
   do {
       i--;
       if ( (num >> i) & 1 )
          lcd0_type('1');
       else
          lcd0_type('0');
   }
   while (i > 0);
}


#define OP_NONE 0
#define OP_PLUS 1
#define OP_START 4

int keycode;
byte ch;
byte a;
byte b;
byte oper;
byte digit;


void main()
{
  PE_low_level_init();

  oper = OP_START;

	for(;;) {
	  if (keybrd0_KbHit()) {
        keycode = keybrd0_GetKeyCode();
        ch = keystatus2char(keycode);
        digit = ch - 48;

        if (oper == OP_START) {
          oper = OP_NONE;
          lcd0_clr();
          a = 0;
          b = 0;
        }

        if (oper == OP_NONE) {
          if (ch == '0') {
            a <<= 1;
            lcd0_type(ch);
          } else if (ch == '1') {
            a <<= 1;
            a |= 1;
            lcd0_type(ch);
          } else if (ch == '#') {
            oper = OP_PLUS;
            lcd0_clr();
          }
        } else if (oper == OP_PLUS ) {
            if (ch == '0') {
              b <<= 1;
              b |= digit;
              lcd0_type(ch);
            } else
            if (ch == '1') {
              b <<= 1;
              b |= digit;
              lcd0_type(ch);
            } else
            if (ch == 'D') {
              a += b;
              // vypis binarniho cisla
              lcd0_clr();
              print(a);
              oper = OP_START;
            }
        }



    }
	}

}
