/*
    DEMO:     repeater zadanych znaku
    VARIANTA: s preruseni
    25.10.2007

    ing.Rudolf Schonecker & ing.Zbynek Krivka
    schonec@fit.vutbr.cz, krivka@fit.vutbr.cz

    OVLADANI:
      1) stisknuti libovolne klavesy
            pro 'C' ==> maze obrazovku
            jine    ==> vypisuje stisknute klavesy za sebe
      2) lze pokracovat ad 1)

    - u vstupu ani pri vypoctu se nekontroluje preteceni !!!
*/

#define byte unsigned char
#define bool unsigned char


// KB Bean - Globalni interrupt flagy - pocitadla vyskytu preruseni...
int keybrd0_keystatus;
bool keybrd0_keypressed;

// Globalni promenne
byte keybrd0_port;
byte lcd0_port;
byte RegStack[16];

// Rozhrani LCD
void lcd0_type(byte charcode);
void lcd0_clr(void);

// Rozhrani KB
void keybrd0_Enable(void);           
void keybrd0_Disable(void);
void keybrd0_EnableEvent(void);
void keybrd0_DisableEvent(void);
void keybrd0_OnInterrupt(void);
void keybrd0_SetEdge(byte edge);
bool keybrd0_KbHit(void);
int keybrd0_GetKeyCode();


void PE_low_level_init();
void PE_low_level_init()
{
  // inicializovat hodnoty portu = konstanty
	keybrd0_port	 = 10;     // 0A
	lcd0_port      = 16;     // 10

  // vynulovat pocitadla vyskytu preruseni od jednotlivych extint beanu
	lcd0_clr();
	
	keybrd0_EnableEvent();

	#asm   // nyni lze povolit preruseni..
			ENABLE INTERRUPT
	#endasm
}


byte keystatus2char(int keycode);
byte keystatus2char(int keycode)
{
  byte retval;
  byte b1;
  byte b2;
  retval = 0;
  b1 = (byte)(keycode>>0); // kod b1 = (byte)(keycode); NEFUNGUJE !!!!!!!!
  b2 = (byte)(keycode>>8);
  if(	  b2>>7 & 1   )    retval = '#';
  if(	  b2>>6 & 1   )    retval = '*';
  if(	  b2>>5 & 1   )    retval = 'D';
  if(	  b2>>4 & 1   )    retval = 'C';
  if(	  b2>>3 & 1   )    retval = 'B';
  if(	  b2>>2 & 1   )    retval = 'A';
  if(	  b2>>1 & 1   )    retval = '9';
  if(	  b2 & 1   )       retval = '8';
  if(	  b1>>7 & 1   )    retval = '7';
  if(	  b1>>6 & 1   )    retval = '6';
  if(	  b1>>5 & 1   )    retval = '5';
  if(	  b1>>4 & 1   )    retval = '4';
  if(	  b1>>3 & 1   )    retval = '3';
  if(	  b1>>2 & 1   )    retval = '2';
  if(	  b1>>1 & 1   )    retval = '1';
  if(	  b1 & 1   )       retval = '0';
  return retval;
}

/*
void print(byte num);
void print(byte num)
{
   byte i;
   i = 8;
   do {
       i--;
       if ( (num >> i) & 1 )
          lcd0_type('1');
       else
          lcd0_type('0'); 
   }
   while (i > 0);
}
*/


int key;
byte chr;

void main()
{
  PE_low_level_init();

	for(;;) {
		if (keybrd0_KbHit()) {
		    key = keybrd0_GetKeyCode();
        chr = keystatus2char(key);
        lcd0_type(chr);		    		    		    		    		    		    		    		    		    		    		    		    		    		    		    

        if (chr == 'C')
          lcd0_clr(); 

		    }   // if kbhit
	}  // for

} // main


// KB Bean
void keybrd0_Enable(void)
{
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    OR      s1, 02               ; nastavi hodnotu enabled do 1
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm
}


void keybrd0_Disable(void)
{
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    AND     s1, FD
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm
}

// Funkce keybrd0_EnableEvent a DisableEvent meni generovany HW a podle nich se pak musi do vysledneho C kodu vlozit 
// prislusne varianty funkci keybrd0_KbHit a keybrd0_GetKeyCode pro ovladani takovychto beanu a musi tomu take odpovidat
// tvar hlavniho programu!!!
void keybrd0_EnableEvent(void) {
 /*
   Tato funkce povoluje preruseni v samotnem kodu a mela by nastavovat genericky parametr KEYBOARD_USES_INTERRUPT := '1';
   popisu designu v design.xml
 */ 
 
 // povolovani preruseni klavesnice za behu programu (nelze reagovat zmenou funkci beanu, ktere by to meli reflektovat)
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    OR      s1, 01               ; nastavi hodnotu enabled do 1
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm 
}

void keybrd0_DisableEvent(void) {
 /*
   Tato funkce zakazuje preruseni v samotnem kodu a mela by nastavovat genericky parametr KEYBOARD_USES_INTERRUPT := '0';
   popisu designu v design.xml
 */ 
 
 // zakazani preruseni klavesnice za behu programu (nelze reagovat zmenou funkci beanu, ktere by to meli reflektovat)
  #asm
    FETCH   s0, _keybrd0_port
    INPUT   s1, (s0)          ; cte hodnotu ridiciho registru
    AND     s1, FE
    OUTPUT  s1, (s0)         ; zapise novou hodnotu ridiciho registru
  #endasm 
}

bool keybrd0_KbHit(void)
{
  bool retval;
  retval = keybrd0_keypressed;
  if (keybrd0_keypressed) {
    keybrd0_keypressed = 0;
  }
  return retval;
}


int keybrd0_GetKeyCode()
{
  return keybrd0_keystatus;  
}


void keybrd0_SetEdge(byte edge)
{
  #asm
    FETCH     TMP, (YL)
    FETCH     s3, _keybrd0_port
    INPUT     s4, (s3)
    LOAD      s3, TMP
    SL0       s3
    SL0       s3
    SL0       s3
    OR        s4, s3
    OR        s3, 07
    AND       s4, s3
    FETCH     s3, _keybrd0_port
    OUTPUT    s4, (s3)
  #endasm
}


// ke kazdemu extint beanu prislusi handler, ktery zapamatuje keystatus, pri vyskytu
// preruseni z daneho beanu - je volan z ISR
void keybrd0_OnInterrupt()
{
  #asm
      ;;; zjisti stavovy vektor -> glb.prom. keybrd0_keystatus
	  FETCH			s0, _keybrd0_port
      ADD       s0, 01             ; dalsi adresa
      INPUT     s1, (s0)
      STORE     s1, _keybrd0_keystatus_low
      ADD       s0, 01             ; dalsi adresa
      INPUT     s2, (s0)
      STORE     s2, _keybrd0_keystatus_high
      LOAD      s2, 01
      STORE     s2, _keybrd0_keypressed
  #endasm
}


//
// LZE VYUZIVAT POUZE REGISTRY  s0, s1
//
interrupt int_handler_asm(void)
{
	#asm
			DISABLE 	INTERRUPT         ; docasne behem zpracovani zakazat preruseni

			LOAD      s0, _RegStack
			STORE     XL, (s0)
			ADD       s0, 01
			STORE     YL, (s0)
			ADD       s0, 01
			STORE     ZL, (s0)
			ADD       s0, 01
			STORE     XH, (s0)
			ADD       s0, 01
			STORE     ZH, (s0)
			ADD       s0, 01
			STORE     TMP, (s0)
			ADD       s0, 01
			STORE     SH, (s0)
			ADD       s0, 01
			STORE     SL, (s0)
			ADD       s0, 01
			STORE     KH, (s0)
			ADD       s0, 01
			STORE     KL, (s0)
			ADD       s0, 01
			STORE     TMP2, (s0)

			FETCH			s0, _keybrd0_port
			INPUT     s1, (s0)
			TEST      s1, 04
			CALL      NZ, _keybrd0_OnInterrupt     ; nastala udalost klavesnice...

			LOAD      s0, _RegStack
			FETCH     XL, (s0)
			ADD       s0, 01
			FETCH     YL, (s0)
			ADD       s0, 01
			FETCH     ZL, (s0)
			ADD       s0, 01
			FETCH     XH, (s0)
			ADD       s0, 01
			FETCH     ZH, (s0)
			ADD       s0, 01
			FETCH     TMP, (s0)
			ADD       s0, 01
			FETCH     SH, (s0)
			ADD       s0, 01
			FETCH     SL, (s0)
			ADD       s0, 01
			FETCH     KH, (s0)
			ADD       s0, 01
			FETCH     KL, (s0)
			ADD       s0, 01
			FETCH     TMP2, (s0)

			RETURNI ENABLE
	#endasm
}

// Bean LCD

void lcd0_clr()
{
  #asm
    FETCH     s3, _lcd0_port
    LOAD      s4, 01
    OUTPUT    s4, (s3)
  #endasm
}

void lcd0_type(byte charcode)
{
  #asm
    FETCH     s3, _lcd0_port
    ADD       s3, 01
    FETCH     TMP, (YL)
    LOAD      s4, TMP
    OUTPUT    s4, (s3)
  #endasm
}